// https://github.com/dancor/wmctrl/blob/master/main.c
unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, Buttons, LCLProc, LCLIntf, LCLType,
  xlib, xatom, cursorfont, x, ctypes, xutil, glib2,  Gtk2Proc, Gtk2Int
  ;

const
  MAX_PROPERTY_VALUE_LEN = 4096;


type
  PAnsiCharArray = ^TAnsiCharArray;
  TAnsiCharArray = array[0..0] of PAnsiChar;

  AtomArray = array [0..0] of TAtom;
  PAtomArray = ^AtomArray;

  { TForm1 }
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private

  public
    Disp:PDisplay;
    procedure Client_msg(Display: PXDisplay; Win: TWindow; msg:Pchar; Data0, Data1, Data2, Data3, Data4:LongWord);
    function get_property(Display: PXDisplay; Win: TWindow; xa_prop_type:TAtom; Prop_Name:PChar; var Size:clong):Pgchar;
    function Get_Window_Title(Display: PXDisplay; Win: TWindow):string;

// gchar *get_window_title (Display *disp, Window win);

    function Get_Client_List(var Size:clong):Pgchar;

    procedure list_windows();

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

Procedure memcpy(Const source: Pointer; dest: Pointer; size: Integer);
Var
  i: Integer;
  b, b2: PByte;
Begin
  b := Source;
  b2 := dest;
  For i := 0 To Size - 1 Do Begin
    b2^ := b^;
    inc(b);
    inc(b2);
  End;
End;


{ TForm1 }
procedure TForm1.FormCreate(Sender: TObject);
var
  x,y,w,h:gint;
begin
  XGetWorkarea(x,y,w,h);

  writeln(x, '||', y, '||', w, '||', h);
  Disp:=XOpenDisplay(nil);
  if Disp = nil then
    writeln('Fehler');
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  Client_msg(Disp, XRootWindow(disp,DefaultScreen(Disp)), '_NET_CURRENT_DESKTOP', 1,0,0,0,0);
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  list_windows();
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin

end;

procedure TForm1.Client_msg(Display: PXDisplay; Win: TWindow; msg: Pchar; Data0, Data1, Data2, Data3, Data4: LongWord);
var
  xClient:TXClientMessageEvent;

  Mask:clong;
begin
  Mask:=SubstructureRedirectMask or SubstructureNotifyMask;

  xclient._type:=ClientMessage;
  xclient.window:= win;
  xclient.message_type:= XInternAtom(Display, msg, False);
  xclient.format:= 32;
  xclient.serial:= 0;
  xclient.send_event:=1;
  xclient.data.l[0]:= data0;
  xclient.data.l[1]:= data1;
  xclient.data.l[2]:= data2;
  xclient.data.l[3]:= data3;
  xclient.data.l[4]:= data4;

  XSendEvent(Disp,DefaultRootWindow(Disp), False, Mask,  PXEvent(Pointer(@xclient)));
  XFlush(Disp);
end; // TForm1.Client_msg

function TForm1.get_property(Display: PXDisplay; Win: TWindow;
  xa_prop_type: TAtom; Prop_Name: PChar; var Size: clong): Pgchar;
var
  xa_prop_name:TAtom;
  xa_ret_type: PAtom ;
  ret_format: Integer;
  ret_nitems: culong;
  ret_bytes_after:clong;
  tmp_size:culong;
  ret_prop: PPcuchar;
  ret:Pgchar;
begin
  xa_prop_name:= XInternAtom(disp, prop_name, False);

  if (XGetWindowProperty(disp, win, xa_prop_name, 0, MAX_PROPERTY_VALUE_LEN div 4, False,
      xa_prop_type, @xa_ret_type, @ret_format,
      @ret_nitems, @ret_bytes_after, @ret_prop) <> Success) then begin
    writeln('Fehler 1');
    exit;
  end;

  {    if (xa_ret_type <> @xa_prop_type) then begin
      XFree(ret_prop);

      writeln('Fehler 2, ',  '||',xa_prop_type);
      exit;
    end;}

  tmp_size:= (ret_format div (32 div sizeof(clong))) * ret_nitems;
  ret:=g_malloc(tmp_size + 1);
  memcpy(ret, ret_prop, tmp_size);
  ret[tmp_size]:=#0;
  size:=tmp_size;

  XFree(ret_prop);

  result:=ret;
end;

function TForm1.Get_Window_Title(Display: PXDisplay; Win: TWindow): string;
var
  RootWin: TWindow;
  WMAtom: TAtom;
  WMWindow: TWindow;

  typeReturned: TAtom;
  formatReturned: Integer;
  nitemsReturned: PtrInt;
  unused: PtrInt;
  data: Pointer;
  // Screen: PGdkScreen;
begin
  Result := '';

  if Display = nil then
    exit;

  RootWin := DefaultRootWindow(Display);
  WMAtom := XInternAtom(Display,'UTF8_STRING', False);

  if XGetWindowProperty(Display, Win, XInternAtom(Display,'_NET_WM_NAME', False), 0, 1024, False, WMAtom,
                        @typeReturned, @formatReturned, @nitemsReturned, @unused, @data) = Success then begin
    if (typeReturned = WMAtom) and (formatReturned = 8) then
      Result := StrPas(Data);
      if Data <> nil then
        XFree(Data);
     Data := nil;
  end;
end; // TForm1.Get_Window_Title

function TForm1.Get_Client_List(var Size: clong): Pgchar;
begin
  result:=get_property(Disp, DefaultRootWindow(Disp),XA_WINDOW, '_NET_CLIENT_LIST', Size);
end; // TForm1.Get_Client_List

procedure TForm1.list_windows();
var
  RootWin: TWindow;
  WMAtom: TAtom;
  ActualTypeReturn: TAtom;
  ActualFormatReturn: LongInt;
  NItemsReturn, BytesAfterReturn: culong;
  Valid: Boolean;
  List:array of TWindow;
  Len, i:Integer;

  WindowTitle:string;

begin
  if Disp= nil then Exit;
  RootWin := DefaultRootWindow(Disp);
  WMAtom := XInternAtom(Disp,'_NET_CLIENT_LIST', False);
  Valid:=XGetWindowProperty(Disp, RootWin, WMAtom, 0, MAX_PROPERTY_VALUE_LEN div 4, False,
                                 AnyPropertyType, @ActualTypeReturn,
                                 @ActualFormatReturn, @NItemsReturn,
                                 @BytesAfterReturn, @List)=0;
  if Valid then begin
    len:=Length(List) - 1;
    writeln('NItemsReturn: ', NItemsReturn);
    writeln('len: ', len);
    for i:=0 to NItemsReturn - 2  do begin
//      writeln(i, ' ', TXID(List[i]));
      if TXID(List[i]) > 0 then begin
        WindowTitle:=Get_Window_Title(Disp, List[i]);
        if WindowTitle <> '' then
        writeln(i, ' "' , format('%s', [WindowTitle]) , '"');
      end;
    end;
  end;

end; // TForm1.list_windows

end.

